<script lang="ts" setup>
import { useproductStore } from '@/stores/Product'
import { usePromotionStore } from '@/stores/Promotion'
import { computed, ref } from 'vue'
import PromotionText from '@/components/PromotionComponent/PromotionText.vue'

const promotionStore = usePromotionStore()
const productStore = useproductStore()

const usingTime = ref(0)
const increase = () => {
  usingTime.value += 1
}
const decrease = () => {
  if (usingTime.value > 0) {
    usingTime.value -= 1
  }
}
</script>
<template>
  <!-- use button group to group it -->
  <!-- use v-model at v-radio group it won't work at the v-radio -->
  <v-radio-group v-model="promotionStore.selectedPromotionId" :mandatory="false">
    <v-list style="height: 500px; overflow-y: scroll; background-color: rgba(180, 143, 81, 1)">
      <div :key="promotion.id" v-for="promotion in promotionStore.searchfilteredPromotions">
        <!-- mb = marginbelow -->
        <v-card
          class="mx-auto my-4"
          width="400"
          prepend-icon="mdi-ticket-percent-outline"
          :id="'card-' + promotion.id"
          :class="{
            cardcannotuse: promotion.status !== 'enable',
            cardcanuse: promotion.status === 'enable'
          }"
        >
          <template v-slot:title>
            {{ promotion.name }}
            <v-radio
              :label="promotion.code"
              :value="promotion.id"
              :disabled="promotion.status !== 'enable'"
            ></v-radio>
            <v-btn
              :class="{
                cardcannotuse: promotion.status !== 'enable',
                radiocanuse: promotion.status === 'enable'
              }"
              class="ma-2"
              size="small"
              rounded
              @click="decrease()"
              >-</v-btn
            >
            {{ usingTime }}
            <v-btn
              :class="{
                cardcannotuse: promotion.status !== 'enable',
                radiocanuse: promotion.status === 'enable'
              }"
              class="ma-2"
              size="small"
              rounded
              @click="increase()"
              >+</v-btn
            >
          </template>

          <v-card-text class="text-body-1">
            <div class="ma-2">
              <PromotionText :promotionItems="promotion.promotionItems"></PromotionText>
            </div>

            <v-expansion-panels>
              <v-expansion-panel
                title="รายละเอียด"
                :class="{
                  cardcannotuse: promotion.status !== 'enable',
                  cardcanuse: promotion.status === 'enable'
                }"
              >
                <v-expansion-panel-text class="text-body-2">
                  <p>วันเริ่มโปรโมชั่น: {{ promotion.startdate }}</p>
                  <p>วันสิ้นสุดโปรโมชั่น: {{ promotion.enddate }}</p>
                  <p>สถานะ: {{ promotion.status === 'enable' ? 'เปิดใช้งาน' : 'ปิดใช้งาน' }}</p>
                </v-expansion-panel-text>
              </v-expansion-panel>
            </v-expansion-panels>
          </v-card-text>
        </v-card>
      </div>
    </v-list>
  </v-radio-group>
</template>
<style scoped>
/* this style for card that is not enable */
.cardcannotuse {
  background-color: #a2a2a2;
}

.cardcanuse {
  background-color: #ffffff;
}

.radiocanuse {
  background-color: #e5e4e2;
}
</style>
